# cmd_discord.py
from discord.ext import commands
from cmd_common import common_commands as cc
from modules.permissions import has_permission

def setup(bot):
    @bot.command()
    async def greet(ctx):
        result = cc.greet(ctx.author.display_name, "Discord")
        await ctx.send(result)

    @bot.command()
    async def ping(ctx):
        result = cc.ping()
        await ctx.send(result)

    @bot.command()
    async def howl(ctx):
        """Calls the shared !howl logic."""
        result = cc.howl(ctx.author.display_name)
        await ctx.send(result)

    @bot.command()
    async def reload(ctx):
        """ Dynamically reloads Discord commands. """
        try:
            import cmd_discord
            import importlib
            importlib.reload(cmd_discord)
            cmd_discord.setup(bot)
            await ctx.send("Commands reloaded!")
        except Exception as e:
            await ctx.send(f"Error reloading commands: {e}")

    @bot.command()
    async def hi(ctx):
        user_id = str(ctx.author.id)
        user_roles = [role.name.lower() for role in ctx.author.roles]  # Normalize to lowercase

        if not has_permission("hi", user_id, user_roles, "discord"):
            await ctx.send("You don't have permission to use this command.")
            return

        await ctx.send("Hello there!")